/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef IMPL_TYPE_SENSORMEASUREMENT_H
#define IMPL_TYPE_SENSORMEASUREMENT_H

#include "impl_type_string.h"
#include "impl_type_int32.h"
#include "impl_type_point3d.h"

struct SensorMeasurement {
    ::String sensor_id;
    ::Int32 id{ 0 };
    ::Point3D position;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(sensor_id);
        fun(id);
        fun(position);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(sensor_id);
        fun(id);
        fun(position);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("sensor_id", sensor_id);
        fun("id", id);
        fun("position", position);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("sensor_id", sensor_id);
        fun("id", id);
        fun("position", position);
    }

    friend bool operator==(const ::SensorMeasurement& lhs, const ::SensorMeasurement& rhs) noexcept
    {
        return (lhs.sensor_id == rhs.sensor_id) && (lhs.id == rhs.id) && (lhs.position == rhs.position);
    }
};


#endif // IMPL_TYPE_SENSORMEASUREMENT_H
